## scikit-learn 0.20.2+dfsg

=== doc/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD  ?= sphinx-build
PAPER         =
BUILDDIR      = _build
ifneq ($(EXAMPLES_PATTERN),)
    EXAMPLES_PATTERN_OPTS := -D sphinx_gallery_conf.filename_pattern="$(EXAMPLES_PATTERN)"
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS)\
    $(EXAMPLES_PATTERN_OPTS) .


.PHONY: help clean html dirhtml pickle json latex latexpdf changes linkcheck doctest optipng

all: html-noplot

help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html      to make standalone HTML files"
	@echo "  dirhtml   to make HTML files named index.html in directories"
	@echo "  pickle    to make pickle files"
	@echo "  json      to make JSON files"
	@echo "  latex     to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  changes   to make an overview of all changed/added/deprecated items"
	@echo "  linkcheck to check all external links for integrity"
	@echo "  doctest   to run all doctests embedded in the documentation (if enabled)"

clean:
	-rm -rf $(BUILDDIR)/*
	-rm -rf auto_examples/
	-rm -rf generated/*
	-rm -rf modules/generated/

html:
	# These two lines make the build a bit more lengthy, and the
	# the embedding of images more robust
	rm -rf $(BUILDDIR)/html/_images
	#rm -rf _build/doctrees/
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html/stable
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html/stable"

html-noplot:
	$(SPHINXBUILD) -D plot_gallery=0 -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html/stable
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html/stable."

dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	make -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

download-data:
	python -c "from sklearn.datasets.lfw import _check_fetch_lfw; _check_fetch_lfw()"

# Optimize PNG files. Needs OptiPNG. Change the -P argument to the number of
# cores you have available, so -P 64 if you have a real computer ;)
optipng:
	find _build auto_examples */generated -name '*.png' -print0 \
	  | xargs -0 -n 1 -P 4 optipng -o10

dist: html latexpdf
	cp _build/latex/user_guide.pdf _build/html/stable/_downloads/scikit-learn-docs.pdf

=== debian/changelog ===
scikit-learn (0.20.2+dfsg-6) unstable; urgency=medium

  * Team upload.
  * Skip test_check_estimator_pairwise test on armhf (another segfault)

 -- Ole Streicher <olebole@debian.org>  Mon, 28 Jan 2019 20:26:29 +0100

scikit-learn (0.20.2+dfsg-5) unstable; urgency=medium

  * Team upload.
  * Skip test_check_estimator_clones test on armhf (another segfault)

 -- Ole Streicher <olebole@debian.org>  Mon, 28 Jan 2019 14:25:52 +0100

scikit-learn (0.20.2+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Skip another armhf test that leads to a segfault

 -- Ole Streicher <olebole@debian.org>  Mon, 28 Jan 2019 09:20:16 +0100

scikit-learn (0.20.2+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Move skipped tests from d/rules into a patch
  * Remaining fixes
  * Verbose test output

 -- Ole Streicher <olebole@debian.org>  Sun, 27 Jan 2019 17:29:31 +0100

scikit-learn (0.20.2+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Skip tests that fail on non-intel platforms. Closes: #919918

 -- Ole Streicher <olebole@debian.org>  Sun, 27 Jan 2019 11:41:13 +0100

scikit-learn (0.20.2+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.20.2+dfsg
  * Rediff patches

 -- Ole Streicher <olebole@debian.org>  Sat, 26 Jan 2019 21:48:46 +0100

scikit-learn (0.20.1+dfsg-3) unstable; urgency=medium

  * Team upload.

  [ Stuart Prescott ]
  * Update Standards-Version to 4.3.0 (no changes required).
  * Move source.lintian-overrides to new location.
  * Fix short descriptions for Python modules packages to not be identical.
  * Fix location of documentation in doc-base file.

  [ Mattia Rizzolo ]
  * Fix FTBFS of the binary-arch targets.  Closes: 919409

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 16 Jan 2019 14:57:47 +0100

scikit-learn (0.20.1+dfsg-2) unstable; urgency=medium

  * Team upload.

  [ Stuart Prescott ]
  * Remove broken parallel building.  Closes: #911830; MR: !1
    - remove broken parallel building.
    - use pybuild replacements rather than trying to second guess
      pybuild internal details.

  [ Mo Zhou ]
  * Fix keyword expression for ppc64el.

  [ Mattia Rizzolo ]
  * d/rules:
    + Set HOME=$(CURDIR)/tmp.  Closes: #915078
    + Manually delete some _configtest* files that appeared out of nowhere.

 -- Mattia Rizzolo <mattia@debian.org>  Sat, 12 Jan 2019 10:34:13 +0100

=== debian/control ===
Source: scikit-learn
Section: python
Priority: optional
Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
Build-Depends: debhelper (>= 9~),
               dh-python,
               python-all-dev (>= 2.6.6-3~),
               python-setuptools,
               python-numpy (>= 1:1.8.2~), python-scipy,
               python-nose, python-pytest,
               python-matplotlib,
               python-joblib (>= 0.9.2),
               python3-all-dev,
               cython3,
               python3-setuptools,
               python3-numpy, python3-scipy,
               python3-nose, python3-pytest,
               python3-matplotlib,
               python3-joblib (>= 0.9.2),
               libsvm-dev (>= 2.84.0),
               libblas-dev | libblas.so,
               libatlas-base-dev,
               python-pandas <!nocheck>, python3-pandas <!nocheck>,
               python-pil <!nocheck>, python3-pil <!nocheck>,
Build-Depends-Indep: python3-sphinx (>= 1.0),
                     python3-sphinx-gallery,
                     python3-numpydoc,
                     python3-pandas,
                     python3-skimage,
                     python3-pil,
                     librsvg2-bin,
                     graphviz,
                     python3-doc,
                     python-numpy-doc,
                     python-scipy-doc,
                     python-matplotlib-doc,
Standards-Version: 4.3.0
Vcs-Browser: https://salsa.debian.org/science-team/scikit-learn
Vcs-Git: https://salsa.debian.org/science-team/scikit-learn.git
Homepage: http://scikit-learn.sourceforge.net

Package: python-sklearn
Replaces: python-scikits-learn (<< 0.9~)
Breaks: python-scikits-learn (<< 0.9~)
Architecture: all
Depends: ${misc:Depends}, ${python:Depends}, python-numpy, python-scipy, python-sklearn-lib(>= ${source:Version}),
         python-joblib (>= 0.9.2),
Provides: ${python:Provides}
Recommends: python-nose, python-pytest, python-matplotlib
Suggests: python-dap, python-scikits-optimization, python-sklearn-doc, ipython
Enhances: python-mvpa2, python-mdp
Description: Python modules for machine learning and data mining - Python 2
 scikit-learn is a collection of Python modules relevant to
 machine/statistical learning and data mining.  Non-exhaustive list of
 included functionality:
  - Gaussian Mixture Models
  - Manifold learning
  - kNN
  - SVM (via LIBSVM)

Package: python-sklearn-lib
Conflicts: python-scikits-learn-lib
Replaces: python-scikits-learn-lib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python-numpy
Provides: ${python:Provides}
Description: low-level implementations and bindings for scikit-learn
 This is an add-on package for python-sklearn. It provides
 low-level implementations and custom Python bindings for the LIBSVM
 library.

Package: python3-sklearn
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}, python3-numpy, python3-scipy, python3-sklearn-lib(>= ${source:Version}),
         python3-joblib (>= 0.9.2),
Recommends: python3-nose, python3-pytest, python3-matplotlib
Suggests: python3-dap, python-sklearn-doc, ipython3
Enhances: python3-mvpa2, python3-mdp
Provides: ${python3:Provides}
Description: Python modules for machine learning and data mining - Python 3
 scikit-learn is a collection of Python modules relevant to
 machine/statistical learning and data mining.  Non-exhaustive list of
 included functionality:
  - Gaussian Mixture Models
  - Manifold learning
  - kNN
  - SVM (via LIBSVM)
 .
 This package contains the Python 3 version.

Package: python3-sklearn-lib
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy
Provides: ${python3:Provides}
Description: low-level implementations and bindings for scikit-learn - Python 3
 This is an add-on package for python-sklearn. It provides
 low-level implementations and custom Python bindings for the LIBSVM
 library.
 .
 This package contains the Python 3 version.


Package: python-sklearn-doc
Conflicts: python-scikits-learn-doc
Replaces: python-scikits-learn-doc
Architecture: all
Section: doc
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
         ${sphinxdoc:Depends},
         libjs-bootstrap,
         libjs-mathjax,
Built-Using: ${sphinxdoc:Built-Using},
Suggests: python-sklearn
Description: documentation and examples for scikit-learn
 This package contains documentation and example scripts for
 python-sklearn.

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

# See also: skimage

PY2VERS ?= $(shell pyversions -vr)
PY3VER  ?= $(shell py3versions -vd)
PY3VERS ?= $(shell py3versions -vr)

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

export DEB_CFLAGS_MAINT_APPEND :=
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  JOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
  JOBS := 1
endif
export JOBS := $(JOBS)

include /usr/share/dpkg/architecture.mk

PYBUILD_TEST_ARGS = -m "not network" -v

# Some tests are known to fail randomly so need to be excluded ATM
ifeq ($(DEB_HOST_ARCH),arm64)
  # A bit aggressive exclusion of some tests which exhibit a problem I have no time to deal with on arm64
  PYBUILD_TEST_ARGS += -k-test_dump
endif

export PYBUILD_TEST_PYTEST := 1
# python2 soon deprecated -- doctests unreliable
export PYBUILD_TEST_ARGS_python2 := $(PYBUILD_TEST_ARGS)
export PYBUILD_TEST_ARGS_python3 := $(PYBUILD_TEST_ARGS)
export JOBLIB_MULTIPROCESSING := $(shell expr $(JOBS) / $$(expr $(words $(PY2VERS)) + $(words $(PY3VERS))))

# try to prevent unsunctioned downloads
export http_proxy := http://127.0.0.1:9/
export https_proxy := http://127.0.0.1:9/

# things in the doc building and tests try to access stuff in HOME (https://bugs.debian.org/915078)
export HOME=$(CURDIR)/tmp

%:
	dh $@ --with python2,python3,sphinxdoc --buildsystem pybuild  --parallel

%-arch:
	dh $@ --with python2,python3 --buildsystem pybuild --parallel

clean:
	dh $@ --with python2,python3 --buildsystem pybuild --parallel

override_dh_clean:
	dh_clean
	rm -rf .pytest_cache build scikit_learn.egg-info tmp
	-mv PKG-INFO-BAK PKG-INFO
	rm -f debian/build-stamp-*
	for i in $$(find -name '*.pyx'); do \
		rm -f $${i%.*}.c $${i%.*}.cpp; \
	done
	for i in $$(find -name '*.pyx.in'); do \
		rm -f $${i%.*}; \
	done
ifneq (,$(filter python-sklearn-doc,$(shell dh_listpackages)))
	+$(MAKE) -C doc clean
endif

#debian/build-stamp-pyx:
override_dh_auto_configure:
	mkdir -p tmp
	-mv PKG-INFO PKG-INFO-BAK
	python$(PY3VER) setup.py config
# 	dh_auto_configure
	mv PKG-INFO-BAK PKG-INFO

# Ensure sample and test data are copied to .pybuild
define PYBUILD_AFTER_BUILD
  for d in tests/data data descr images; do
    rm -rf {build_dir}/sklearn/datasets/$$d;
    ln -s {dir}/sklearn/datasets/$$d {build_dir}/sklearn/datasets/$$d;
  done;
endef
export PYBUILD_AFTER_BUILD

# Only with the default Python 3, additionally use pybuild to run
# sphinx once the build is complete
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
# FIXME: urllib.error.URLError -- have to ignore
define PYBUILD_AFTER_BUILD_python$(PY3VER)
  $(PYBUILD_AFTER_BUILD)
  PYTHONPATH={build_dir} \
  SPHINXBUILD="python$(PY3VER) -m sphinx -j $(JOBS) -D mathjax_path=MathJax.js" \
  SPHINXOPTS="-j $(JOBS) -D mathjax_path=MathJax.js" \
  $(MAKE) -C doc html || true;
  [ -d doc/_build/html ]
endef
export PYBUILD_AFTER_BUILD_python$(PY3VER)
endif

define PYBUILD_BEFORE_TEST
  (cd {build_dir} && python{version} -c 'import sklearn;  sklearn.show_versions()')
endef
export PYBUILD_BEFORE_TEST

export PYBUILD_AFTER_INSTALL = rm -f {destdir}/{install_dir}/_configtest*

override_dh_auto_build-arch:
	# Don't try to build docs in the arch build, so unset that hook
	env -u PYBUILD_AFTER_BUILD_python$(PY3VER) \
		dh_auto_build

override_dh_auto_test-indep:

override_dh_auto_install:
	dh_auto_install
	# cleanup python3 cache (mixing python3 subversions)
	-find debian/tmp -name "__pycache__" -exec rm -r {} +

override_dh_installdocs-arch:
	dh_installdocs -A README*.rst

override_dh_installdocs-indep:
	dh_installdocs -A README*.rst
ifneq (,$(filter python-sklearn-doc,$(shell dh_listpackages)))
    docdir=debian/python-sklearn-doc/usr/share/doc/python-sklearn-doc; \
	if [ -e $$docdir/stable ] ; then \
	mv \
		$$docdir/stable $$docdir/html; \
    fi
endif

override_dh_installchangelogs:
	dh_installchangelogs doc/whats_new.rst

# remove .so libraries from main package, and call dh_numpy*
_dh_python%:
	-find debian/python$(*:2=)-sklearn/usr/lib -name "*.so" -delete;

	dh_numpy$(*:2=) -ppython$(*:2=)-sklearn-lib
	dh_python$*

override_dh_python2: _dh_python2
override_dh_python3: _dh_python3

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc

override_dh_sphinxdoc-indep:
	@# no need to filter out this call, if sphinxdoc is not used it won't be called.
	dh_sphinxdoc -XMathJax.js -Xjquery.js


## to prepare next Debian upstream source tarball
dfsg: dfsg-releases
dfsg-%:
	git checkout dfsg
	-git merge --no-commit $*
	-git rm -rf sklearn/externals/joblib
	: # -git rm -f ./sklearn/svm/src/libsvm/svm.*
	git commit -m "Merge $* into DFSG (pruning externals: joblib)" -a
	git checkout debian

## scikit-learn 0.20.3+dfsg

=== debian/changelog ===
scikit-learn (0.20.3+dfsg-0ubuntu4) focal; urgency=medium

  * No-change rebuild to drop python3.7.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 18 Feb 2020 09:23:12 +0100

scikit-learn (0.20.3+dfsg-0ubuntu3) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 18 Oct 2019 18:53:39 +0000

scikit-learn (0.20.3+dfsg-0ubuntu2) eoan; urgency=medium

  * Drop python2 support.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 16 Aug 2019 00:23:31 -0700

scikit-learn (0.20.3+dfsg-0ubuntu1) eoan; urgency=medium

  * New upstream release

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 01 May 2019 17:15:57 +0100

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,11 @@
 Source: scikit-learn
 Section: python
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
 Build-Depends: debhelper (>= 9~),
                dh-python,
-               python-all-dev (>= 2.6.6-3~),
-               python-setuptools,
-               python-numpy (>= 1:1.8.2~), python-scipy,
-               python-nose, python-pytest,
-               python-matplotlib,
-               python-joblib (>= 0.9.2),
                python3-all-dev,
                cython3,
                python3-setuptools,
@@ -21,8 +16,8 @@
                libsvm-dev (>= 2.84.0),
                libblas-dev | libblas.so,
                libatlas-base-dev,
-               python-pandas <!nocheck>, python3-pandas <!nocheck>,
-               python-pil <!nocheck>, python3-pil <!nocheck>,
+               python3-pandas <!nocheck>,
+               python3-pil <!nocheck>,
 Build-Depends-Indep: python3-sphinx (>= 1.0),
                      python3-sphinx-gallery,
                      python3-numpydoc,
@@ -39,36 +34,6 @@
 Vcs-Browser: https://salsa.debian.org/science-team/scikit-learn
 Vcs-Git: https://salsa.debian.org/science-team/scikit-learn.git
 Homepage: http://scikit-learn.sourceforge.net
-
-Package: python-sklearn
-Replaces: python-scikits-learn (<< 0.9~)
-Breaks: python-scikits-learn (<< 0.9~)
-Architecture: all
-Depends: ${misc:Depends}, ${python:Depends}, python-numpy, python-scipy, python-sklearn-lib(>= ${source:Version}),
-         python-joblib (>= 0.9.2),
-Provides: ${python:Provides}
-Recommends: python-nose, python-pytest, python-matplotlib
-Suggests: python-dap, python-scikits-optimization, python-sklearn-doc, ipython
-Enhances: python-mvpa2, python-mdp
-Description: Python modules for machine learning and data mining - Python 2
- scikit-learn is a collection of Python modules relevant to
- machine/statistical learning and data mining.  Non-exhaustive list of
- included functionality:
-  - Gaussian Mixture Models
-  - Manifold learning
-  - kNN
-  - SVM (via LIBSVM)
-
-Package: python-sklearn-lib
-Conflicts: python-scikits-learn-lib
-Replaces: python-scikits-learn-lib
-Architecture: any
-Depends: ${misc:Depends}, ${shlibs:Depends}, ${python:Depends}, python-numpy
-Provides: ${python:Provides}
-Description: low-level implementations and bindings for scikit-learn
- This is an add-on package for python-sklearn. It provides
- low-level implementations and custom Python bindings for the LIBSVM
- library.
 
 Package: python3-sklearn
 Architecture: all
@@ -100,7 +65,6 @@
  .
  This package contains the Python 3 version.
 
-
 Package: python-sklearn-doc
 Conflicts: python-scikits-learn-doc
 Replaces: python-scikits-learn-doc

=== debian/rules ===
--- 
+++ 
@@ -3,7 +3,6 @@
 
 # See also: skimage
 
-PY2VERS ?= $(shell pyversions -vr)
 PY3VER  ?= $(shell py3versions -vd)
 PY3VERS ?= $(shell py3versions -vr)
 
@@ -30,10 +29,8 @@
 endif
 
 export PYBUILD_TEST_PYTEST := 1
-# python2 soon deprecated -- doctests unreliable
-export PYBUILD_TEST_ARGS_python2 := $(PYBUILD_TEST_ARGS)
 export PYBUILD_TEST_ARGS_python3 := $(PYBUILD_TEST_ARGS)
-export JOBLIB_MULTIPROCESSING := $(shell expr $(JOBS) / $$(expr $(words $(PY2VERS)) + $(words $(PY3VERS))))
+export JOBLIB_MULTIPROCESSING := $(shell expr $(JOBS) / $(words $(PY3VERS)))
 
 # try to prevent unsunctioned downloads
 export http_proxy := http://127.0.0.1:9/
@@ -43,13 +40,13 @@
 export HOME=$(CURDIR)/tmp
 
 %:
-	dh $@ --with python2,python3,sphinxdoc --buildsystem pybuild  --parallel
+	dh $@ --with python3,sphinxdoc --buildsystem pybuild  --parallel
 
 %-arch:
-	dh $@ --with python2,python3 --buildsystem pybuild --parallel
+	dh $@ --with python3 --buildsystem pybuild --parallel
 
 clean:
-	dh $@ --with python2,python3 --buildsystem pybuild --parallel
+	dh $@ --with python3 --buildsystem pybuild --parallel
 
 override_dh_clean:
 	dh_clean
@@ -140,7 +137,6 @@
 	dh_numpy$(*:2=) -ppython$(*:2=)-sklearn-lib
 	dh_python$*
 
-override_dh_python2: _dh_python2
 override_dh_python3: _dh_python3
 
 ## immediately useable documentation and exemplar scripts/data

## scikit-learn 0.22.1+dfsg

=== doc/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -j auto
 SPHINXBUILD  ?= sphinx-build
 PAPER         =
 BUILDDIR      = _build
@@ -13,7 +13,7 @@
 # Internal variables.
 PAPEROPT_a4     = -D latex_paper_size=a4
 PAPEROPT_letter = -D latex_paper_size=letter
-ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS)\
+ALLSPHINXOPTS   = -T -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS)\
     $(EXAMPLES_PATTERN_OPTS) .
 
 
@@ -98,7 +98,7 @@
 	      "results in $(BUILDDIR)/doctest/output.txt."
 
 download-data:
-	python -c "from sklearn.datasets.lfw import _check_fetch_lfw; _check_fetch_lfw()"
+	python -c "from sklearn.datasets._lfw import _check_fetch_lfw; _check_fetch_lfw()"
 
 # Optimize PNG files. Needs OptiPNG. Change the -P argument to the number of
 # cores you have available, so -P 64 if you have a real computer ;)

=== debian/changelog ===
scikit-learn (0.22.1+dfsg-1) unstable; urgency=medium

  * New upstream release; Closes: #933366, #935315
  * Drop python2 autopkgtests, no longer needed
  * debian/copyright
    - update copyright information
  * Refresh patches for new upstream code
  * debian/rules
    - stop building doc until sphinx 2.* is available
    - update how we run test: move sklearn/conftest.py out of the way (it
      somehow conflicts with the file {build_dir}) and skip to run
      test_old_pickle
  * debian/python-sklearn-doc.docs
    - comment out the HTML documentation, which we have disable for now

 -- Sandro Tosi <morph@debian.org>  Sun, 12 Jan 2020 01:17:10 -0500

scikit-learn (0.20.3+dfsg-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.
  * Stop building the Python2 package. Closes: #938444.

 -- Matthias Klose <doko@debian.org>  Sun, 10 Nov 2019 14:46:27 +0100

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: scikit-learn
 Section: python
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
 Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
 Build-Depends: debhelper (>= 9~),
                dh-python,

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,9 @@
 include /usr/share/dpkg/architecture.mk
 
 PYBUILD_TEST_ARGS = -m "not network" -v
+
+# until https://github.com/scikit-learn/scikit-learn/issues/16101 is fixed
+PYBUILD_TEST_ARGS += -k-test_old_pickle
 
 # Some tests are known to fail randomly so need to be excluded ATM
 ifeq ($(DEB_HOST_ARCH),arm64)
@@ -82,23 +85,25 @@
 
 # Only with the default Python 3, additionally use pybuild to run
 # sphinx once the build is complete
-ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
-# FIXME: urllib.error.URLError -- have to ignore
-define PYBUILD_AFTER_BUILD_python$(PY3VER)
-  $(PYBUILD_AFTER_BUILD)
-  PYTHONPATH={build_dir} \
-  SPHINXBUILD="python$(PY3VER) -m sphinx -j $(JOBS) -D mathjax_path=MathJax.js" \
-  SPHINXOPTS="-j $(JOBS) -D mathjax_path=MathJax.js" \
-  $(MAKE) -C doc html || true;
-  [ -d doc/_build/html ]
-endef
-export PYBUILD_AFTER_BUILD_python$(PY3VER)
-endif
+## ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
+## # FIXME: urllib.error.URLError -- have to ignore
+## define PYBUILD_AFTER_BUILD_python$(PY3VER)
+##   $(PYBUILD_AFTER_BUILD)
+##   PYTHONPATH={build_dir} \
+##   SPHINXBUILD="python$(PY3VER) -m sphinx -j $(JOBS) -D mathjax_path=MathJax.js" \
+##   SPHINXOPTS="-j $(JOBS) -D mathjax_path=MathJax.js" \
+##   $(MAKE) -C doc html || true;
+##   [ -d doc/_build/html ]
+## endef
+## export PYBUILD_AFTER_BUILD_python$(PY3VER)
+## endif
 
 define PYBUILD_BEFORE_TEST
-  (cd {build_dir} && python{version} -c 'import sklearn;  sklearn.show_versions()')
+  (mv $(CURDIR)/sklearn/conftest.py $(CURDIR)/sklearn/conftest.py.test ; cd {build_dir} && python{version} -c 'import sklearn;  sklearn.show_versions()')
 endef
 export PYBUILD_BEFORE_TEST
+
+export PYBUILD_AFTER_TEST=mv $(CURDIR)/sklearn/conftest.py.test $(CURDIR)/sklearn/conftest.py
 
 export PYBUILD_AFTER_INSTALL = rm -f {destdir}/{install_dir}/_configtest*

## scikit-learn 0.22.2.post1+dfsg

=== debian/changelog ===
scikit-learn (0.22.2.post1+dfsg-5) unstable; urgency=medium

  * Team upload.

  * Skip another failing test on armhf. This should resolve the last of the
  * current FTBFS.

 -- Christian Kastner <ckk@debian.org>  Tue, 31 Mar 2020 17:10:32 +0200

scikit-learn (0.22.2.post1+dfsg-4) unstable; urgency=medium

  * Team upload.

  * Skip another failing test on armhf
  * Skip a non-deterministically failing ppc64el test

 -- Christian Kastner <ckk@debian.org>  Mon, 30 Mar 2020 11:47:33 +0200

scikit-learn (0.22.2.post1+dfsg-3) unstable; urgency=medium

  * Team upload.

  * Skip another failing test on armhf
  * autopkgtest: Disable tests requiring network

 -- Christian Kastner <ckk@debian.org>  Mon, 30 Mar 2020 09:25:31 +0200

scikit-learn (0.22.2.post1+dfsg-2) unstable; urgency=medium

  * Team upload.

  * Skip yet another flaky test on ppc64el, hopefully resolving the FTBFS now
  * autopkgtest:
    - Disable doctest, as we do at build time
    - Sync excluded tests with build-time exclusions

 -- Christian Kastner <ckk@debian.org>  Sun, 29 Mar 2020 20:46:08 +0200

scikit-learn (0.22.2.post1+dfsg-1) unstable; urgency=medium

  * Team upload.

  * New upstream release.
    - Refresh patches
  * debian/rules:
    - Merge multiple pytest -k expressions into one. Fixes a FTBFS on arm64
    - Skip a number of failing tests on ppc64el, fixing a FTBFS. Issue has been
      reported upstream

 -- Christian Kastner <ckk@debian.org>  Sun, 29 Mar 2020 13:11:58 +0200

scikit-learn (0.22.1+dfsg-2) unstable; urgency=medium

  * Team upload.

  * Update patch to skip broken armel test. Resolves a FTBFS on armel
  * d/control:
    - Bump Standards-Version to 4.5.0
    - Set Rules-Requires-Root to no
  * d/rules
    - Change attempt to skip failing test_old_pickle
    - Also skip known-flaky test_ard_accuracy_on_easy_problem
  * d/copyright:
    - Fix File pattern for libsvm, liblinear
    - Drop copyright for no longer included cblas
    - Fix License names and bodies
  * autopkgtest: Replace deprecated ADTTMP with AUTOPKGTEST_TMP
  * Drop obsolete code in patch deb_use_system_joblib
  * Refresh revision for GitHub source links
  * Add overrides for lintian warnings re: external patches
  * Add (temporary) lintian overrides for E: source-is-missing
    These files are not used, and will be excluded in the next source repack
  * Add DEP-3 headers to patches missing them

 -- Christian Kastner <ckk@debian.org>  Thu, 13 Feb 2020 16:52:57 +0100

=== debian/control ===
--- 
+++ 
@@ -29,7 +29,8 @@
                      python-numpy-doc,
                      python-scipy-doc,
                      python-matplotlib-doc,
-Standards-Version: 4.3.0
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/science-team/scikit-learn
 Vcs-Git: https://salsa.debian.org/science-team/scikit-learn.git
 Homepage: http://scikit-learn.sourceforge.net

=== debian/rules ===
--- 
+++ 
@@ -22,14 +22,38 @@
 
 PYBUILD_TEST_ARGS = -m "not network" -v
 
-# until https://github.com/scikit-learn/scikit-learn/issues/16101 is fixed
-PYBUILD_TEST_ARGS += -k-test_old_pickle
+# until the following are fixed:
+#  https://github.com/scikit-learn/scikit-learn/issues/16101
+#  https://github.com/scikit-learn/scikit-learn/issues/15420
+EXCLUDE_TESTS = not test_old_pickle and not test_ard_accuracy_on_easy_problem
 
 # Some tests are known to fail randomly so need to be excluded ATM
 ifeq ($(DEB_HOST_ARCH),arm64)
   # A bit aggressive exclusion of some tests which exhibit a problem I have no time to deal with on arm64
-  PYBUILD_TEST_ARGS += -k-test_dump
+  EXCLUDE_TESTS += and not test_dump
 endif
+
+# Until this is fixed:
+# https://github.com/scikit-learn/scikit-learn/issues/16794
+ifeq ($(DEB_HOST_ARCH),ppc64el)
+  EXCLUDE_TESTS += and not test_precomputed_nearest_neighbors_filtering
+  EXCLUDE_TESTS += and not test_stacking_cv_influence
+  # This is actually a test generator, so this skips a *lot* of tests
+  EXCLUDE_TESTS += and not test_common
+  # This one is flaky (appears to be non-deterministic)
+  EXCLUDE_TESTS += and not test_stacking_with_sample_weight
+endif
+
+# These consistently fail on the buildds, but could not be reproduced on a
+# porter box, and therefore requires more investigation
+ifeq ($(DEB_HOST_ARCH),armhf)
+  EXCLUDE_TESTS += and not test_check_estimators_stacking_estimator
+  EXCLUDE_TESTS += and not test_check_estimators_voting_estimator
+  # This is actually a test generator, so this skips a *lot* of tests
+  EXCLUDE_TESTS += and not test_common
+endif
+
+PYBUILD_TEST_ARGS += -k "$(EXCLUDE_TESTS)"
 
 export PYBUILD_TEST_PYTEST := 1
 export PYBUILD_TEST_ARGS_python3 := $(PYBUILD_TEST_ARGS)

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,uversionmangle=s/(\d)[_\.\-\+]?((RC|rc|pre|dev|beta|alpha)\d*)$/$1~$2/" \
 https://pypi.python.org/simple/scikit-learn .*/scikit-learn-@ANY_VERSION@@ARCHIVE_EXT@#sha256=.*

## scikit-learn 0.23.2

=== debian/changelog ===
scikit-learn (0.23.2-5ubuntu6) jammy; urgency=medium

  * Do not test the wminkowski distance function which
    was removed in scipy 1.8
  * Cherry-pick upstream commit to fix test_rank_deficient_design
  * Exclude failing docstring parameters tests

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 05 Apr 2022 14:31:03 +0000

scikit-learn (0.23.2-5ubuntu5) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 23:53:03 +0000

scikit-learn (0.23.2-5ubuntu4) jammy; urgency=medium

  * Cherry-pick upstream commits for numpy 1.20 compatibility

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 21 Nov 2021 16:59:47 +0000

scikit-learn (0.23.2-5ubuntu3) jammy; urgency=medium

  * No-change rebuild to add python3.10.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 17 Oct 2021 15:59:34 +0200

scikit-learn (0.23.2-5ubuntu2) hirsute; urgency=medium

  * Exclude test_compare_to_ELKI in the autopkgtest as well

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 08 Feb 2021 19:57:21 +0000

scikit-learn (0.23.2-5ubuntu1) hirsute; urgency=medium

  * Exclude test_compare_to_ELKI on ppc64el to avoid FTBFS

 -- Graham Inggs <ginggs@ubuntu.com>  Sun, 07 Feb 2021 18:50:31 +0000

scikit-learn (0.23.2-5) unstable; urgency=medium

  * Team upload.
  * debian patch skip_test_ELKI_PR19115.patch applies upstream
    PR19115 to skip the flaky ELKI test on arm and 32 bit systems.

 -- Drew Parsons <dparsons@debian.org>  Tue, 19 Jan 2021 22:20:59 +1100

scikit-learn (0.23.2-4) unstable; urgency=medium

  * Team upload.
  * debian patch fix_scipy1.6_PR18711.patch applies parts of upstream
    PR#18711 to fix handling with scipy 1.6 (in particular fixes
    sklearn/utils/optimize.py)
  * debhelper compatibility level 13
  * Standards-Version: 4.5.1

 -- Drew Parsons <dparsons@debian.org>  Mon, 18 Jan 2021 02:47:23 +1100

scikit-learn (0.23.2-3) unstable; urgency=medium

  * autopkgtest: Fix exclusion of test_gaussian_kde on s390x, alpha, ppc64
    (Closes: #969523)
  * Add lintian override for embedded-javascript-library in python-sklearn-doc

 -- Christian Kastner <ckk@debian.org>  Sat, 05 Sep 2020 20:43:10 +0200

scikit-learn (0.23.2-2) unstable; urgency=medium

  * Exclude armhf tests again erroneously assumed to be fixed
  * Sync autopkgtest test exclusions with d/rules

 -- Christian Kastner <ckk@debian.org>  Mon, 17 Aug 2020 00:05:08 +0200

scikit-learn (0.23.2-1) unstable; urgency=medium

  * New upstream version 0.23.2
    - Refresh patches
  * Patch cleanup:
    - Drop non-used patches from series.
      These patches address things that are no longer relevant to the code, or
      have been addressed in other patches
    - Drop two more unused patches, remove their lintian overrides
    - Unify armel div-by-zero patches
    - Drop Skip-failing-non-intel-tests.patch, fixed upstream
    - Rename patches
  * Update ppc64el test skips

 -- Christian Kastner <ckk@debian.org>  Sun, 16 Aug 2020 12:43:04 +0200

scikit-learn (0.23.1-4) unstable; urgency=medium

  * Add Increase-tolerance-for-RANSACRegressor-test.patch
  * Update Change-expected-result-type-to-pass-on-32-bit.patch
  * Fix Revert-removal-of-NumPy-div-by-zero-check.patch on armel
  * Exclude another armhf test (Bus error)
  * Exclude tests failing with SciPy >= 1.5 on s390x, alpha, ppc64

 -- Christian Kastner <ckk@debian.org>  Thu, 06 Aug 2020 11:03:59 +0200

scikit-learn (0.23.1-3) unstable; urgency=medium

  * Exclude two failing ppc64el tests for now
  * Exclude test_assess_dimesion_rank_one
  * Exclude failing test (memory) on armhf
  * Add Fix-test_float_precision-fails.patch
  * Add Revert-removal-of-NumPy-div-by-zero-check.patch
  * Add Use-assert_allclose-instead-of-equality-in-FP-comparison.patch
  * Add Change-expected-result-type-to-pass-on-32-bit.patch

 -- Christian Kastner <ckk@debian.org>  Tue, 04 Aug 2020 18:45:11 +0200

scikit-learn (0.23.1-2) unstable; urgency=medium

  * Add matplotlib-3.3-fix.patch
    Fixes FTBFS from test failures with matplotlib >= 3.3

 -- Christian Kastner <ckk@debian.org>  Wed, 29 Jul 2020 17:34:09 +0200

scikit-learn (0.23.1-1) unstable; urgency=medium

  * New upstream release.
    - Refresh patches
    - Add patches
      + Skip-two-tests-when-SciPy-1.5.patch
      + Add Skip-k-means-convergence-tests.patch
    - Drop obsolete patches
      + Fix-for-test_uniform_grid.patch
      + debian/patches/deb_use_system_joblib

  * Set python-sklearn-doc to Multi-Arch: foreign
  * Drop Files-Excluded from d/copyright. None of the patterns match anymore.
  * Drop no longer necessary +dfsg suffix and repacking
  * Add python-pandas-doc to Build-Depends-Indep for intersphinx mapping
  * Add python3-threadpoolctl to Build-Depends and Depends
  * Bump python3-numpydoc dependency to 0.9.0
  * Update lintian source overrides
  * Drop obsolete copyright stanza
  * Add myself to Uploaders

 -- Christian Kastner <ckk@debian.org>  Sat, 16 May 2020 19:16:21 +0200

scikit-learn (0.22.2.post1+dfsg-7) unstable; urgency=medium

  * Team upload.

  * Re-add a clean target that excludes dh_sphinxdoc.
    Fixes FTBFS for arch:any, as sphinx is in Build-Depends-Indep.

 -- Christian Kastner <ckk@debian.org>  Mon, 04 May 2020 12:13:10 +0200

scikit-learn (0.22.2.post1+dfsg-6) unstable; urgency=medium

  * Team upload.

  * Add Fix-for-test_uniform_grid.patch
    Cherry-picked from upstream. (Closes: #959139)
  * Bump debhelper to 12 and switch to debhelper-compat
  * Mark python3-sklearn-lib as Multi-Arch: same
  * Re-enable build of documentation, which the following updates needed for
    the new scikit-learn-modern theme:
    - Update update python-sklearn-doc.{doc-base, links)
    - Bump Depends from libjs-bootstrap to libjs-bootstrap4
    - Add Use-local-MathJax.patch
    - Add Disable-BinderHub-links.patch
  * debian/rules refactoring and minor improvements

 -- Christian Kastner <ckk@debian.org>  Mon, 04 May 2020 08:36:38 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,12 @@
 Source: scikit-learn
 Section: python
 Priority: optional
-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Yaroslav Halchenko <debian@onerussian.com>, Michael Hanke <michael.hanke@gmail.com>
-Build-Depends: debhelper (>= 9~),
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
+Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
+           Michael Hanke <michael.hanke@gmail.com>,
+           Christian Kastner <ckk@debian.org>,
+Build-Depends: debhelper-compat (= 13),
                dh-python,
                python3-all-dev,
                cython3,
@@ -12,6 +15,7 @@
                python3-nose, python3-pytest,
                python3-matplotlib,
                python3-joblib (>= 0.9.2),
+               python3-threadpoolctl (>= 2.0.0),
                libsvm-dev (>= 2.84.0),
                libblas-dev | libblas.so,
                libatlas-base-dev,
@@ -19,7 +23,7 @@
                python3-pil <!nocheck>,
 Build-Depends-Indep: python3-sphinx (>= 1.0),
                      python3-sphinx-gallery,
-                     python3-numpydoc,
+                     python3-numpydoc (>= 0.9),
                      python3-pandas,
                      python3-skimage,
                      python3-pil,
@@ -29,8 +33,9 @@
                      python-numpy-doc,
                      python-scipy-doc,
                      python-matplotlib-doc,
+                     python-pandas-doc,
 Rules-Requires-Root: no
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Vcs-Browser: https://salsa.debian.org/science-team/scikit-learn
 Vcs-Git: https://salsa.debian.org/science-team/scikit-learn.git
 Homepage: http://scikit-learn.sourceforge.net
@@ -38,7 +43,7 @@
 Package: python3-sklearn
 Architecture: all
 Depends: ${misc:Depends}, ${python3:Depends}, python3-numpy, python3-scipy, python3-sklearn-lib(>= ${source:Version}),
-         python3-joblib (>= 0.9.2),
+         python3-joblib (>= 0.9.2), python3-threadpoolctl (>= 2.0.0),
 Recommends: python3-nose, python3-pytest, python3-matplotlib
 Suggests: python3-dap, python-sklearn-doc, ipython3
 Enhances: python3-mvpa2, python3-mdp
@@ -56,6 +61,7 @@
 
 Package: python3-sklearn-lib
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-numpy
 Provides: ${python3:Provides}
 Description: low-level implementations and bindings for scikit-learn - Python 3
@@ -69,11 +75,12 @@
 Conflicts: python-scikits-learn-doc
 Replaces: python-scikits-learn-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
 Build-Profiles: <!nodoc>
 Depends: ${misc:Depends},
          ${sphinxdoc:Depends},
-         libjs-bootstrap,
+         libjs-bootstrap4,
          libjs-mathjax,
 Built-Using: ${sphinxdoc:Built-Using},
 Suggests: python-sklearn

=== debian/rules ===
#!/usr/bin/make -f
# -*- mode: makefile; coding: utf-8 -*-

# See also: skimage

include /usr/share/dpkg/architecture.mk

PY3VER  ?= $(shell py3versions -vd)
PY3VERS ?= $(shell py3versions -vr)

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

export DEB_CFLAGS_MAINT_APPEND :=
export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  JOBS := $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
else
  JOBS := 1
endif
export JOBS := $(JOBS)
export JOBLIB_MULTIPROCESSING := $(shell expr $(JOBS) / $(words $(PY3VERS)))

# things in the doc building and tests try to access stuff in HOME (https://bugs.debian.org/915078)
export HOME=$(CURDIR)/tmp


# until the following are fixed:
#  https://github.com/scikit-learn/scikit-learn/issues/16101
#  https://github.com/scikit-learn/scikit-learn/issues/15420
EXCLUDE_TESTS = not test_old_pickle
EXCLUDE_TESTS += and not test_ard_accuracy_on_easy_problem

# Exclude failing docstring parameters tests
EXCLUDE_TESTS += and not test_docstring_parameters
EXCLUDE_TESTS += and not test_check_docstring_parameters

# Some tests are known to fail randomly so need to be excluded ATM
ifeq ($(DEB_HOST_ARCH),arm64)
  # A bit aggressive exclusion of some tests which exhibit a problem I have no time to deal with on arm64
  EXCLUDE_TESTS += and not test_dump
endif

# Until this is fixed:
# https://github.com/scikit-learn/scikit-learn/issues/16794
ifeq ($(DEB_HOST_ARCH),ppc64el)
  EXCLUDE_TESTS += and not test_precomputed_nearest_neighbors_filtering
  # This is actually a test generator, so this skips a *lot* of tests
  EXCLUDE_TESTS += and not test_common
  # These are is flaky
  EXCLUDE_TESTS += and not test_stacking_cv_influence
  EXCLUDE_TESTS += and not test_stacking_with_sample_weight
  # Fails when built with -O3
  EXCLUDE_TESTS += and not test_compare_to_ELKI
endif

# Until these are fixed:
# https://github.com/scikit-learn/scikit-learn/issues/16443
# https://github.com/scikit-learn/scikit-learn/issues/13052
ifeq ($(DEB_HOST_ARCH),armhf)
  EXCLUDE_TESTS += and not test_check_estimators_stacking_estimator
  EXCLUDE_TESTS += and not test_check_estimators_voting_estimator
  EXCLUDE_TESTS += and not test_apply_path_readonly_all_trees
  EXCLUDE_TESTS += and not test_check_estimator
  EXCLUDE_TESTS += and not test_check_estimator_clones
  EXCLUDE_TESTS += and not test_check_estimator_pairwise
  EXCLUDE_TESTS += and not test_novelty_true_common_tests
  # This is actually a test generator, so this skips a *lot* of tests
  EXCLUDE_TESTS += and not test_common
endif

# TBD. See https://bugs.debian.org/967977
ifeq ($(DEB_HOST_ARCH),s390x)
  EXCLUDE_TESTS += and not test_gaussian_kde
endif
ifeq ($(DEB_HOST_ARCH),alpha)
  EXCLUDE_TESTS += and not test_gaussian_kde
endif
# Same test, but not entirely the same results as above. Assuming same cause
ifeq ($(DEB_HOST_ARCH),ppc64)
  EXCLUDE_TESTS += and not test_gaussian_kde
endif


%:
	dh $@ --with python3,sphinxdoc --buildsystem pybuild

%-arch:
	dh $@ --with python3 --buildsystem pybuild

clean:
	dh $@ --with python3 --buildsystem pybuild

override_dh_clean:
	dh_clean
	rm -rf .pytest_cache build scikit_learn.egg-info tmp
	-mv PKG-INFO-BAK PKG-INFO
	rm -f debian/build-stamp-*
	for i in $$(find -name '*.pyx'); do \
		rm -f $${i%.*}.c $${i%.*}.cpp; \
	done
	for i in $$(find -name '*.pyx.in'); do \
		rm -f $${i%.*}; \
	done
ifneq (,$(filter python-sklearn-doc,$(shell dh_listpackages)))
	+$(MAKE) -C doc clean
endif

override_dh_auto_configure:
	mkdir -p tmp
	-mv PKG-INFO PKG-INFO-BAK
	python$(PY3VER) setup.py config
# 	dh_auto_configure
	mv PKG-INFO-BAK PKG-INFO

# Ensure sample and test data are copied to .pybuild
define PYBUILD_AFTER_BUILD
  for d in tests/data data descr images; do
    rm -rf {build_dir}/sklearn/datasets/$$d;
    ln -s {dir}/sklearn/datasets/$$d {build_dir}/sklearn/datasets/$$d;
  done;
endef
export PYBUILD_AFTER_BUILD
# Only with the default Python 3, additionally use pybuild to run
# sphinx once the build is complete.
ifeq (,$(filter nodoc,$(DEB_BUILD_OPTIONS)))
define PYBUILD_AFTER_BUILD_python$(PY3VER)
  $(PYBUILD_AFTER_BUILD)
  PYTHONPATH={build_dir} \
  http_proxy='127.0.0.1.9' \
  https_proxy='127.0.0.1.9' \
  SPHINXBUILD="python$(PY3VER) -m sphinx" \
  $(MAKE) -C doc html SPHINXOPTS="-j $(JOBS)" || true;
  [ -d doc/_build/html ]
endef
export PYBUILD_AFTER_BUILD_python$(PY3VER)
endif
override_dh_auto_build-arch:
	# Don't try to build docs in the arch build, so unset that hook
	env -u PYBUILD_AFTER_BUILD_python$(PY3VER) \
		dh_auto_build


export PYBUILD_TEST_PYTEST := 1
export PYBUILD_TEST_ARGS_python3 := -m "not network" -v -k "$(EXCLUDE_TESTS)"
define PYBUILD_BEFORE_TEST
  (mv $(CURDIR)/sklearn/conftest.py $(CURDIR)/sklearn/conftest.py.test; \
   mv $(CURDIR)/sklearn/datasets/tests/conftest.py $(CURDIR)/sklearn/datasets/tests/conftest.py.test; \
   cd {build_dir} && python{version} -c 'import sklearn; sklearn.show_versions()')
endef
export PYBUILD_BEFORE_TEST
define PYBUILD_AFTER_TEST
  (mv $(CURDIR)/sklearn/conftest.py.test $(CURDIR)/sklearn/conftest.py; \
   mv $(CURDIR)/sklearn/datasets/tests/conftest.py.test $(CURDIR)/sklearn/datasets/tests/conftest.py)
endef
export PYBUILD_AFTER_TEST

# Nothing to do for indep
override_dh_auto_test-indep:

export PYBUILD_AFTER_INSTALL = rm -f {destdir}/{install_dir}/_configtest*
override_dh_auto_install:
	dh_auto_install
	# cleanup python3 cache (mixing python3 subversions)
	-find debian/tmp -name "__pycache__" -exec rm -r {} +


override_dh_installdocs-arch:
	dh_installdocs -A README*.rst

override_dh_installdocs-indep:
	dh_installdocs -A README*.rst
ifneq (,$(filter python-sklearn-doc,$(shell dh_listpackages)))
	docdir=debian/python-sklearn-doc/usr/share/doc/python-sklearn-doc; \
	if [ -e $$docdir/stable ] ; then \
	mv \
		$$docdir/stable $$docdir/html; \
    fi
endif

override_dh_installchangelogs:
	dh_installchangelogs doc/whats_new.rst

# remove .so libraries from main package, and call dh_numpy*
_dh_python%:
	-find debian/python$(*:2=)-sklearn/usr/lib -name "*.so" -delete;

	dh_numpy$(*:2=) -ppython$(*:2=)-sklearn-lib
	dh_python$*

override_dh_python3: _dh_python3

## immediately useable documentation and exemplar scripts/data
override_dh_compress:
	dh_compress -X.py -X.html -X.pdf -X.css -X.jpg -X.txt -X.js -X.json -X.rtc

override_dh_sphinxdoc-indep:
	@# no need to filter out this call, if sphinxdoc is not used it won't be called.
	dh_sphinxdoc -Xsearchtools.js

=== debian/tests/control ===
Tests: python3
Depends: python3-all, python3-nose, python3-sklearn, python3-numpy, python3-scipy, python3-nose, python3-pytest, python3-matplotlib, python3-joblib (>= 0.9.2),
Restrictions: allow-stderr
